diff -urN qmail-1.03-vanilla/qmail-smtpd.c qmail-1.03-md24/qmail-smtpd.c
--- qmail-1.03-vanilla/qmail-smtpd.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-smtpd.c	2007-08-13 21:27:36.000000000 +0200
@@ -193,118 +683,446 @@
           }
   }
 
-  if (addr.len > 900) return 0;
+  if (addr.len > ctl_maxaddrlen) return 0;
   return 1;
 }
 
-int bmfcheck()
+/* return values:
+ *
+ * 0 == not found / no match
+ * 1 == regex matches
+ */
+int bmcheck(int which, char *what)
 {
-  int j;
-  if (!bmfok) return 0;
-  if (constmap(&mapbmf,addr.s,addr.len - 1)) return 1;
-  j = byte_rchr(addr.s,addr.len,'@');
-  if (j < addr.len)
-    if (constmap(&mapbmf,addr.s + j,addr.len - j - 1)) return 1;
+  stralloc *bmb=0;
+  char *type=0;
+  int i=0;
+  regex_t r;
+
+  if (!*what) return 0;
+  switch (which) {
+    case BMCHECK_BMF: type="badmailfrom";  bmb=&bmf; break;
+    case BMCHECK_BMT: type="badmailto";    bmb=&bmt; break;
+    case BMCHECK_BMH: type="badmailhelo";  bmb=&bmh; break;
+    case GMCHECK_GMF: type="goodmailfrom"; bmb=&gmf; break;
+    default: die_control();
+  }
+  if (!bmb) return 0;
+
+  for (i=0; i < bmb->len; i+=strlen(bmb->s+i)+1) {
+    if (ctl_log_bmchecks) {
+      doname();Log("checking ");Log(type);Log(": ");
+    }
+    if (regcomp(&r,bmb->s+i,REG_NOSUB|REG_EXTENDED) == 0) {
+      if (ctl_log_bmchecks) {
+        char *buf=alloca(strlen(bmb->s+i)+strlen(what)+100);
+        int j=fmt_str(buf,"\"");
+        j+=fmt_str(buf+j,bmb->s+i);
+        j+=fmt_str(buf+j,"\" / \"");
+        j+=fmt_str(buf+j,what);
+        j+=fmt_str(buf+j,"\"  (");
+        j+=fmt_ulong(buf+j,i);
+        j+=fmt_str(buf+j,"/");
+        j+=fmt_ulong(buf+j,bmb->len);
+        j+=fmt_str(buf+j,")\n");
+        buf[j]=0; Log(buf);
+      }
+      if (regexec(&r,what,0,0,0) == 0) { regfree(&r); return 1; }
+    } else {
+      char *buf=alloca(strlen(bmb->s+i)+strlen(what)+100);
+      int j=fmt_str(buf,"FAILED REGEX: regcomp(\"");
+      j+=fmt_str(buf+j,bmb->s+i);
+      j+=fmt_str(buf+j,"\" / \"");
+      j+=fmt_str(buf+j,what);
+      j+=fmt_str(buf+j,"\") lengths: (");
+      j+=fmt_ulong(buf+j,i);
+      j+=fmt_str(buf+j,"/");
+      j+=fmt_ulong(buf+j,bmb->len);
+      j+=fmt_str(buf+j,")\n");
+      buf[j]=0; Log(buf);
+    }
+  }
   return 0;
 }
 
 int addrallowed()
 {
   int r;
+
   r = rcpthosts(addr.s,str_len(addr.s));
   if (r == -1) die_control();
+
   return r;
 }
 
+/* news-mail-abuse-YYYYMMDD@svc-box.de */
+int datecheck(void)
+{
+  int len=0;
+
+  if (!ctl_datechecks) return 0;
 
-int seenmail = 0;
-int flagbarf; /* defined if seenmail */
-stralloc mailfrom = {0};
-stralloc rcptto = {0};
+  for (;;) {
+    unsigned long days=0;
+    char *start=dcf.s+len, *sep;
+    int slen;
+
+    len+=strlen(start)+1; /* for the next one */
+    sep=start+str_chr(start, ':');
+    if (!*sep) {
+      slen=strlen(start);
+    } else {
+      if (scan_ulong(sep+1, &days) == 0) die_control();
+      slen=sep-start;
+    }
+    if (days <= 0) days=7; /* default is a week */
+    if (slen > addr.len) continue;
 
-void smtp_helo(arg) char *arg;
-{
-  smtp_greet("250 "); out("\r\n");
-  seenmail = 0; dohelo(arg);
+    if (!case_diffb(addr.s, slen, start)) {
+      time_t max=time(0);
+      time_t min=max-60*60*24*days; /* (60sek * 60min * 24h = tage) */
+      unsigned long actual;
+      if (scan_ulong(addr.s+slen,&actual)==8) {
+        char *x=addr.s+slen;
+        time_t check;
+        struct tm t;
+        t.tm_sec=t.tm_min=t.tm_hour=0;
+        t.tm_year=(x[0]-'0')*1000 + (x[1]-'0')*100 + (x[2]-'0')*10 + (x[3]-'0');
+        t.tm_mon= (x[4]-'0')*10 + (x[5]-'0');
+        t.tm_mday=(x[6]-'0')*10 + (x[7]-'0');
+        t.tm_year-=1900; t.tm_mon-=1;
+        check=mktime(&t);
+        if (ctl_log_datechecks) {
+          doname(); Log("doing datecheck: "); Log(start); Log(" / "); Log(addr.s); Log("\n");
+        }
+        if (check<min || check>max) die_date();
+      }
+    }
+
+    if (len >= dcf.len) break;
+  }
+
+  return 0;
 }
-void smtp_ehlo(arg) char *arg;
+
+stralloc smtptext = {0};
+
+void get(char *ch)
 {
-  smtp_greet("250-"); out("\r\n250-PIPELINING\r\n250 8BITMIME\r\n");
-  seenmail = 0; dohelo(arg);
+  substdio_get(&smtpfrom,ch,1);
+  if (*ch != '\r')
+    if (smtptext.len < HUGESMTPTEXT)
+      if (!stralloc_append(&smtptext,ch)) die_nomem();
 }
-void smtp_rset()
+
+unsigned int smtpcode(void)
 {
-  seenmail = 0;
-  out("250 flushed\r\n");
+  char ch;
+  unsigned int code;
+
+  if (!stralloc_copys(&smtptext,"")) die_nomem();
+
+  get(&ch); code = ch - '0';
+  get(&ch); code = code * 10 + (ch - '0');
+  get(&ch); code = code * 10 + (ch - '0');
+  for (;;) {
+    get(&ch);
+    if (ch != '-') break;
+    while (ch != '\n') get(&ch);
+    get(&ch); get(&ch); get(&ch);
+  }
+  while (ch != '\n') { get(&ch); }
+
+  return code;
 }
-void smtp_mail(arg) char *arg;
+
+/**
+ * ip_is_in_mx_blacklist() - test, if the ip isn't allowed as mx
+ *
+ * 0 = okay
+ * 1 = not okay (is listed)
+ */
+int ip_is_in_mx_blacklist(struct ip_address *mx)
 {
-  if (!addrparse(arg)) { err_syntax(); return; }
-  flagbarf = bmfcheck();
-  seenmail = 1;
-  if (!stralloc_copys(&rcptto,"")) die_nomem();
-  if (!stralloc_copys(&mailfrom,addr.s)) die_nomem();
-  if (!stralloc_0(&mailfrom)) die_nomem();
-  out("250 ok\r\n");
-}
-void smtp_rcpt(arg) char *arg; {
-  if (!seenmail) { err_wantmail(); return; }
-  if (!addrparse(arg)) { err_syntax(); return; }
-  if (flagbarf) { err_bmf(); return; }
-  if (relayclient) {
-    --addr.len;
-    if (!stralloc_cats(&addr,relayclient)) die_nomem();
-    if (!stralloc_0(&addr)) die_nomem();
+  int i,k=0;
+  char *x;
+  struct ip_address ip;
+
+  for (i=0; i < mxbl.len; i+=strlen(mxbl.s+i)+1) {
+    x=mxbl.s+i;
+    k=ip_scan(mxbl.s, &ip);
+    if (k) {
+      if (byte_equal(mx, sizeof(struct ip_address), &ip)) {
+	return 1;
+      }
+    }
+    k=0;
   }
-  else
-    if (!addrallowed()) { err_nogateway(); return; }
-  if (!stralloc_cats(&rcptto,"T")) die_nomem();
-  if (!stralloc_cats(&rcptto,addr.s)) die_nomem();
-  if (!stralloc_0(&rcptto)) die_nomem();
-  out("250 ok\r\n");
+
+  return 0;
 }
 
+void mfcheck_close(void)
+{
+  timeoutwrite(timeout, smtpfrom.fd,"RSET\r\n", 6);
+  timeoutwrite(timeout, smtpfrom.fd,"QUIT\r\n", 6);
+  close(smtpfrom.fd);
+  return;
+}
 
-int saferead(fd,buf,len) int fd; char *buf; int len;
+/* mail from: check
+ *
+ *  0 = okay
+ * -1 = dns soft
+ * -2 = dns hard
+ * -3 = dns mem
+ * -4 = callback temp. failed (DNS_VRFY)
+ */
+int mfcheck(void)
 {
-  int r;
-  flush();
-  r = timeoutread(timeout,fd,buf,len);
-  if (r == -1) if (errno == error_timeout) die_alarm();
-  if (r <= 0) die_read();
-  return r;
+  stralloc sa = {0};
+  ipalloc ia = {0};
+  unsigned int random;
+  int i,code;
+
+  if (authdone) return 0; /* valid auth. was done, no need for checking */
+  if (ctl_mfcheck <= 0) return 0; /* mfcheck is disabled */
+
+  i = byte_rchr(addr.s, addr.len, '@') + 1;
+  if (i >= addr.len) return 0;
+  random = now() + (getpid() << 16);
+  dns_init(0);
+  if (!stralloc_copys(&sa, addr.s + i)) die_nomem();
+  i = dns_mxip(&ia,&sa,random);
+  if (i < 0) return i; /* -1 -2 -3 */
+  if (ia.len < 1) { stralloc_0(&sa); return DNS_SOFT; }
+  if (ctl_mfcheck <= 1) return 0; /* mfcheck is only 1 */
+
+  /* SMTP callback/sender verification */
+  for (i=0; i<ia.len; ++i) { /* TODO */
+
+    if (ip_is_in_mx_blacklist(&ia.ix[i].ip)) {
+      tarpit("451", "4.1.8", "bad sender's system address, your mx is blacklisted!");
+    }
+
+    smtpfrom.p=smtpfrom.n=0;
+    smtpfrom.fd=socket(AF_INET,SOCK_STREAM,0);
+    smtpfrom.p=smtpfrom.n=0;
+    if (smtpfrom.fd == -1) { die_nosocket(); }
+    if (ipme_is(&ia.ix[i].ip)) return 0;
+
+    if (timeoutconn(smtpfrom.fd, &ia.ix[i].ip, &outip, 25, timeoutconnect) != 0) {
+      tarpit("451", "4.1.8", "bad sender's system address, can't contact your mx!");
+    }
+
+    code = smtpcode();
+    if (code >= 400) {
+      mfcheck_close();
+      continue; /* try next one */
+    }
+
+    if (!stralloc_ready(&sa,20+me.len)) die_nomem();
+    if (!stralloc_copys(&sa,"HELO ")) die_nomem();
+    if (!stralloc_cat(&sa,&me)) die_nomem();
+    if (!stralloc_cats(&sa,"\r\n")) die_nomem();
+    if (timeoutwrite(timeout,smtpfrom.fd,sa.s,sa.len) == -1) {
+      tarpit("451", "4.1.8", "bad sender's system address, sending data failed!");
+    }
+
+    code = smtpcode();
+    if (code >= 400) {
+      mfcheck_close();
+      continue; /* try next one */
+    }
+
+    if (timeoutwrite(timeout,smtpfrom.fd,"MAIL FROM:<>\r\n",14) == -1) {
+      tarpit("451", "4.1.8", "bad sender's system address, sending data failed!");
+    }
+
+    code = smtpcode();
+    if (code >= 400) {
+      mfcheck_close();
+      continue; /* try next one */
+    }
+
+    if (!stralloc_ready(&sa,20+addr.len)) die_nomem();
+    if (!stralloc_copys(&sa,"RCPT TO:<")) die_nomem();
+    if (!stralloc_cats(&sa, addr.s)) die_nomem();
+    if (!stralloc_cats(&sa,">\r\n")) die_nomem();
+    if (timeoutwrite(timeout,smtpfrom.fd,sa.s,sa.len) == -1) {
+      tarpit("451", "4.1.8", "bad sender's mailbox address, sending data failed!");
+    }
+
+    code = smtpcode();
+    if (code >= 500) { /* temp. errors are okay / greylisting! */
+      if (!stralloc_copys(&sa, "bad sender's mailbox address, RCPT TO:<")) die_nomem();
+      if (!stralloc_cats(&sa, addr.s)) die_nomem();
+      if (!stralloc_cats(&sa, "> failed")) die_nomem();
+      if (!stralloc_0(&sa)) die_nomem();
+      mfcheck_close();
+      tarpit2("550", "5.1.8", sa.s, "BounceTest: ", &smtptext);
+    }
+
+    mfcheck_close(); /* testbounce was okay */
+    if (!stralloc_copys(&sa, "bad sender's mailbox address, RCPT TO:<")) die_nomem();
+    if (!stralloc_cats(&sa, addr.s)) die_nomem();
+    if (!stralloc_cats(&sa, "> failed")) die_nomem();
+    if (!stralloc_0(&sa)) die_nomem();
+    return 0; /* return OK */
+  } /* for(all mx) */
+
+  return DNS_VRFY;
 }
 
-char ssinbuf[1024];
-substdio ssin = SUBSTDIO_FDBUF(saferead,0,ssinbuf,sizeof ssinbuf);
+int rcptcheck(void)
+{
+  int pid;
+  int wstat;
+  char *av[2] = { rcptchk.s, 0 };
+
+  if (!ctl_rcptchecks) return 0;
+
+  switch (pid=fork()) {
+    case -1:
+      die_fork();
+      break;
+    case 0:
+      if (!env_put2("SENDER", mailfrom.s)) die_nomem();
+      if (!env_put2("RECIPIENT", addr.s)) die_nomem();
+      execv(av[0], av);
+      _exit(120);
+      break;
+  }
+
+  if (wait_pid(&wstat,pid) == -1) die_with3();
+  if (wait_crashed(wstat)) die_with3();
+
+  switch (wait_exitcode(wstat)) {
+    case   0: return 0;
+    case   2: die_with2();
+    case  11: die_with11();
+    case  12: die_with12();
+    case  13: die_with13();
+    case  14: die_with14();
+    case  15: return 0;
+    case  16: die_with16();
+    case  17: die_with17();
+    case  18: die_with18();
+    case  21: die_with21();
+    case  22: die_with22();
+    case 111: die_with111();
+    case 112: die_with112();
+  }
+
+  /* invalid addresses */
+  return 1;
+}
 
 struct qmail qqt;
 unsigned int bytestooverflow = 0;
+stralloc clamtext = {0};
 
-void put(ch)
-char *ch;
+void clamget(char *ch)
 {
+  substdio_get(&clamdsock,ch,1);
+  if (*ch != '\r')
+    if (clamtext.len < HUGESMTPTEXT)
+      if (!stralloc_append(&clamtext,ch)) die_nomem();
+}
+
+void put(char *ch)
+{
+  if (clamd_streamok) {
+    if (timeoutwrite(timeout,clamssock.fd,ch,1) == -1) {
+      doname();
+      Log("problem sending data to clamd stream, skipping the scan!\n");
+      flush();
+      /* we have reached the maximum stream length? */
+      close(clamdsock.fd); close(clamssock.fd); clamd_streamok=0;
+    }
+  }
+
   if (bytestooverflow)
     if (!--bytestooverflow)
       qmail_fail(&qqt);
+
   qmail_put(&qqt,ch,1);
 }
 
-void blast(hops)
-int *hops;
+unsigned int clamport(void)
+{
+  char ch;
+  unsigned int port;
+
+  for (;;) { clamget(&ch); if (ch == ' ') break; }
+  if (!stralloc_copys(&clamtext,"")) die_nomem();
+  for (;;) { clamget(&ch); if (ch == '\n') break; }
+  clamtext.s[clamtext.len]=0;
+  if (scan_ulong(clamtext.s, &port) == 0) return 0;
+
+  return port;
+}
+
+void blast(int *hops)
 {
   char ch;
   int state;
   int flaginheader;
-  int pos; /* number of bytes since most recent \n, if fih */
+  unsigned int pos; /* number of bytes since most recent \n, if fih */
   int flagmaybex; /* 1 if this line might match RECEIVED, if fih */
   int flagmaybey; /* 1 if this line might match \r\n, if fih */
   int flagmaybez; /* 1 if this line might match DELIVERED, if fih */
- 
+
   state = 1;
   *hops = 0;
   flaginheader = 1;
   pos = 0; flagmaybex = flagmaybey = flagmaybez = 1;
+
+  if (ctl_clamd) {
+    clamd_streamok = 0; /* reset to unknown state */
+    if (clamd.s) {
+      /* use unix domain socket for control connection */
+      struct sockaddr_un un;
+      clamdsock.fd = socket(AF_UNIX,SOCK_STREAM,0);
+      if (clamdsock.fd == -1) goto blast;
+      un.sun_family = AF_UNIX;
+      un.sun_path[fmt_strn(un.sun_path, clamd.s, sizeof(un.sun_path))]=0;
+      if (connect(clamdsock.fd, (struct sockaddr*)&un, sizeof(un)) == -1) {
+        doname(); Log("problem while connecting to clamd unix socket!\n"); flush();
+        goto blast;
+      }
+    } else {
+      /* use tcp stream for control connection */
+      clamdsock.fd = socket(AF_INET,SOCK_STREAM,0);
+      if (clamdsock.fd == -1) {
+        doname(); Log("problem creating socket for clamd control connection!\n"); flush();
+        goto blast;
+      }
+      if (timeoutconn(clamdsock.fd, &clamd_ip, &outip, clamd_port, timeoutconnect) != 0) {
+        doname(); Log("problem while connecting to clamd!\n"); flush();
+        goto blast;
+      }
+    }
+    /* scanning stream */
+    clamssock.fd = socket(AF_INET,SOCK_STREAM,0);
+    if (clamssock.fd == -1) {
+      doname(); Log("problem creating socket for clamd scan stream!\n"); flush();
+      goto blast;
+    }
+    if (timeoutwrite(timeout,clamdsock.fd,"STREAM\n",7) == -1) {
+      doname(); Log("problem sending STREAM command to clamd!\n"); flush();
+      goto blast;
+    }
+    clamd_sport = clamport();
+    if (clamd_sport == 0) goto blast;
+    if (timeoutconn(clamssock.fd, &clamd_ip, &outip, clamd_sport, timeoutconnect) != 0) {
+      doname(); Log("problem with connecting to clamd stream!\n"); flush();
+      goto blast;
+    }
+    clamd_streamok=1;
+  }
+
+  blast:
   for (;;) {
     substdio_get(&ssin,&ch,1);
     if (flaginheader) {
@@ -322,17 +1140,17 @@
     }
     switch(state) {
       case 0:
-        if (ch == '\n') straynewline();
+        if (ch == '\n') die_newline();
         if (ch == '\r') { state = 4; continue; }
         break;
       case 1: /* \r\n */
-        if (ch == '\n') straynewline();
+        if (ch == '\n') die_newline();
         if (ch == '.') { state = 2; continue; }
         if (ch == '\r') { state = 4; continue; }
         state = 0;
         break;
       case 2: /* \r\n + . */
-        if (ch == '\n') straynewline();
+        if (ch == '\n') die_newline();
         if (ch == '\r') { state = 3; continue; }
         state = 0;
         break;
@@ -351,71 +1169,426 @@
   }
 }
 
-char accept_buf[FMT_ULONG];
-void acceptmessage(qp) unsigned long qp;
+
+void acceptmessage(unsigned long qp)
 {
+  char accept_buf[FMT_ULONG];
   datetime_sec when;
   when = now();
-  out("250 ok ");
+  doserv(); out("250 2.6.0 ok ");
   accept_buf[fmt_ulong(accept_buf,(unsigned long) when)] = 0;
   out(accept_buf);
   out(" qp ");
   accept_buf[fmt_ulong(accept_buf,qp)] = 0;
   out(accept_buf);
-  out("\r\n");
+  doeol();
 }
 
-void smtp_data() {
+void smtp_data(void) {
   int hops;
   unsigned long qp;
   char *qqx;
- 
+  char at[FMT_ULONG];
+
   if (!seenmail) { err_wantmail(); return; }
-  if (!rcptto.len) { err_wantrcpt(); return; }
+  if (!seenrcpt) { die_wantrcpt(); }
   seenmail = 0;
-  if (databytes) bytestooverflow = databytes + 1;
-  if (qmail_open(&qqt) == -1) { err_qqt(); return; }
+
+  /* rfc 1870 says:
+   * A server is permitted, but not required, to accept a message which
+   * is, in fact, larger than declared in the extended MAIL command, such
+   * as might occur if the client employed a size-estimation heuristic
+   * which was inaccurate.
+   * -> we take 5kb +/- for the given size
+   * -> the size stands for message+headers!
+   */
+  if (ctl_databytes) {
+    bytestooverflow = ctl_databytes + ctl_databytesP;
+  }
+  if (qmail_open(&qqt) == -1) { die_qqt(); }
   qp = qmail_qp(&qqt);
-  out("354 go ahead\r\n");
- 
-  received(&qqt,"SMTP",local,remoteip,remotehost,remoteinfo,fakehelo);
+  out_err("354 go ahead");
+
+  doname(); Log("C: [...] ");
+  at[fmt_ulong(at,bytestooverflow)]=0; Log(" bytestooverflow=");Log(at);
+  Log("\n");
+
+  /* rfc3848 support: ESMTPA => auth | ESMTPS => tls | ESMTPSA => tls+auth */
+  if (tls_started && authdone) {
+    if (!stralloc_cats(&proto, "ESMTPSA")) die_nomem();
+  } else if (authdone) {
+    if (!stralloc_copys(&proto, "SMTPA")) die_nomem();
+  } else if (tls_started) {
+    if (!stralloc_cats(&proto, "ESMTPS")) die_nomem();
+  } else {
+    if (!stralloc_copys(&proto, "SMTP")) die_nomem();
+  }
+  if (!stralloc_0(&proto)) die_nomem();
+
+  received(&qqt,proto.s,local,remoteip,remotehost,remoteinfo,fakehelo);
+  if (ctl_p0fsock) p0f_received(&qqt, remoteip);
   blast(&hops);
-  hops = (hops >= MAXHOPS);
+  hops = (hops >= ctl_maxhops);
   if (hops) qmail_fail(&qqt);
   qmail_from(&qqt,mailfrom.s);
   qmail_put(&qqt,rcptto.s,rcptto.len);
- 
+
+  if (clamd_streamok) {
+    fd_set rfds;
+    struct timeval tv;
+    char ch;
+    stralloc sa = {0};
+
+    close(clamssock.fd);
+    FD_ZERO(&rfds);
+    FD_SET(clamdsock.fd, &rfds);
+    tv.tv_sec = 1; tv.tv_usec = 0;
+    if (select(clamdsock.fd+1, &rfds, NULL, NULL, &tv)) {
+      if (FD_ISSET(clamdsock.fd, &rfds)) {
+	if (!stralloc_copys(&clamtext,"")) die_nomem();
+	for (;;) { clamget(&ch); if (ch == '\n') break; }
+	/* "stream: Worm.Sober.I FOUND\n" -> "Worm.Sober.I" */
+	clamtext.s[clamtext.len-1]=0;
+	if (strstr(clamtext.s, "FOUND")) {
+	  clamtext.s[clamtext.len-7]=0;
+	  doname(); Log("CLAMD: virus '"); Log(clamtext.s+8); Log("' was found!\n"); flush();
+	  if (!stralloc_copys(&sa, "your email contains the virus '")) die_nomem();
+	  if (!stralloc_cats(&sa, clamtext.s+8)) die_nomem();
+	  if (!stralloc_cats(&sa, "'!")) die_nomem();
+	  if (!stralloc_0(&sa)) die_nomem();
+	  tarpit("554", "5.7.7", sa.s);
+	}
+      }
+    }
+    close(clamdsock.fd);
+  }
+
   qqx = qmail_close(&qqt);
   if (!*qqx) { acceptmessage(qp); return; }
-  if (hops) { out("554 too many hops, this message is looping (#5.4.6)\r\n"); return; }
-  if (databytes) if (!bytestooverflow) { out("552 sorry, that message size exceeds my databytes limit (#5.3.4)\r\n"); return; }
-  if (*qqx == 'D') out("554 "); else out("451 ");
-  out(qqx + 1);
-  out("\r\n");
+  if (hops)  { err_tmh(); return; }
+
+  doname(); Log("debug: got a message, which was to big: ");
+  at[fmt_ulong(at,bytestooverflow)]=0; Log(" bytestooverflow=");Log(at);
+  at[fmt_ulong(at,ctl_databytes)]=0; Log(" ctl_databytes=");Log(at);
+  at[fmt_ulong(at,databytes)]=0; Log(" databytes=");Log(at);
+  Log("\n");
+
+  if (ctl_databytes) if (!bytestooverflow) { err_size(); return; }
+  doserv(); if (*qqx == 'D') out("554 "); else out("451 "); out(qqx + 1); doeol();
+}
+
+void setup()
+{
+  char *x=0;
+
+  /* change to QMAILHOME/control */
+  if (chdir(auto_qmail) == -1) die_control();
+
+  die_alarm=&die_alarm1; /* set the  default */
+
+  /* reading control/me */
+  if (control_init() == -1) die_control(); hostname=me.s;
+  if (rcpthosts_init() == -1) die_control();
+
+  /* fill greeting.s */
+  if (control_readfile(&greeting,"control/smtpgreeting",1) != 1) die_control();
+  greeting.s[greeting.len]=0;
+
+  /* overides controlfile */
+  if ((x=getenv("SMTPGREETING"))) {
+    greeting.s=x; greeting.len=strlen(x);
+  }
+
+  /* now the logging stuff */
+  if (control_readint(&ctl_log_in, "control/log/smtp_in") == -1) die_control();
+  if (control_readint(&ctl_log_fd, "control/log/smtp_fd") == -1) die_control();
+  if (control_readint(&ctl_log_out,"control/log/smtp_out") == -1) die_control();
+  if (ctl_log_in  < 0) ctl_log_in=0;
+  if (ctl_log_out < 0) ctl_log_out=0;
+  if (ctl_log_fd  < 0) ctl_log_fd=2;
+  sserr.fd = ctl_log_fd;
+
+  /* is there a p0f socket for remote OS information */
+  ctl_p0fsock=env_get("P0FSOCK");
+  if (!ctl_p0fsock) ctl_p0fsock="control/p0fsock";
+  if ((access(ctl_p0fsock, R_OK|W_OK) != 0)) ctl_p0fsock=0;
+
+  /* checking for viruses with clamav */
+  ctl_clamd = control_readline(&clamd, "control/clamd");
+  if (ctl_clamd == -1) die_control();
+  if (ctl_clamd) {
+    clamd.s[clamd.len]=0;
+    if (clamd.s[0] == '/') {
+      /* hopefully a full path to the socket */
+      clamd.s[clamd.len]=0;
+    } else {
+      /* ip:port */
+      int i=ip_scan(clamd.s, &clamd_ip);
+      if (!i) die_control();
+      i=scan_ulong(clamd.s+i+1, &clamd_port);
+      if (!i) die_control();
+      clamd.s=0;
+    }
+  }
+
+  if (env_get("NO_CLAMD")) {
+    ctl_clamd=0; /* disable checking, regardless of good control files */
+  }
+
+  switch (control_readline(&ctl_outgoingip,"control/outgoingip")) {
+    case -1:
+      if (errno == error_nomem) die_nomem();
+      die_control();
+      break;
+    case 0:
+      if (!stralloc_copys(&ctl_outgoingip, "0.0.0.0")) die_nomem();
+      break;
+  }
+  if (str_equal(ctl_outgoingip.s, "0.0.0.0")) {
+    outip.d[0]=outip.d[1]=outip.d[2]=outip.d[3]=(unsigned long)0;
+  } else if (!ip_scan(ctl_outgoingip.s, &outip)) die_control();
+
+
+
+  ctl_localiphost = control_rldef(&liphost,"control/localiphost",1,(char *) 0);
+  if (ctl_localiphost == -1) die_control();
+
+  if (control_readint(&ctl_timeout,"control/timeoutsmtpd") == -1) die_control();
+  if (ctl_timeout <= 0) ctl_timeout = DEFAULT_TIMEOUT;
+
+  /* log checks of misc stuff ? (all default to off) */
+  if (control_readint(&ctl_log_bmchecks,"control/log/bmchecks") == -1) die_control();
+  if (ctl_log_bmchecks < 0) ctl_log_bmchecks = 0;
+  if (control_readint(&ctl_log_orchecks,"control/log/orchecks") == -1) die_control();
+  if (ctl_log_orchecks < 0) ctl_log_orchecks = 0;
+  if (control_readint(&ctl_log_tarpitting,"control/log/tarpitting") == -1) die_control();
+  if (ctl_log_tarpitting < 0) ctl_log_tarpitting = 0;
+  if (control_readint(&ctl_log_datechecks,"control/log/datechecks") == -1) die_control();
+  if (ctl_log_datechecks < 0) ctl_log_datechecks = 0;
+
+  /* mfcheck patch (dns check) */
+  if (env_get("NO_MFCHECK")) {
+    ctl_mfcheck=0;
+  } else {
+    x = env_get("MFCHECK");
+    if (x) {
+      if (scan_ulong(x,&ctl_mfcheck) == 0) die_control();
+    } else {
+      if (control_readint(&ctl_mfcheck,"control/mfcheck") == -1) die_control();
+    }
+  }
+
+  /* orcheck patch (open relay checks) */
+  if (env_get("NO_ORCHECK")) {
+    ctl_orcheck=0;
+  } else {
+    x = env_get("ORCHECK");
+    if (x) {
+      if (scan_ulong(x,&ctl_orcheck) == 0) die_control();
+    } else {
+      if (control_readint(&ctl_orcheck,"control/orcheck") == -1) die_control();
+    }
+  }
+
+  /* tarpitting */
+  if (env_get("NO_TARPITTING")) {
+    ctl_tarpitcount=0;
+    ctl_tarpitdelay=0;
+  } else {
+    x = env_get("TARPITCOUNT");
+    if (x) {
+      if (scan_ulong(x,&ctl_tarpitcount) == 0) die_control();
+    } else {
+      if (control_readint(&ctl_tarpitcount,"control/tarpitcount") == -1)
+        die_control();
+    }
+    x = env_get("TARPITDELAY");
+    if (x) {
+      if (scan_ulong(x,&ctl_tarpitdelay) == 0) die_control();
+    } else {
+      if (control_readint(&ctl_tarpitdelay,"control/tarpitdelay") == -1)
+        die_control();
+    }
+  }
+
+  if ((x=env_get("BLACKLISTED"))) {
+    /* each "RCPT TO" will be ignored and send to <$BLACKLISTED> */
+    spamfeed=1;
+    if (!stralloc_copys(&rcptto, "T")) die_nomem();
+    if (!stralloc_cats(&rcptto, x)) die_nomem();
+    if (!stralloc_0(&rcptto)) die_nomem();
+  } else if ((x=env_get("RCPTTOFIXED"))) {
+    /* each mail goes to <$RCPTTOFIXED> */
+    ctl_rcpttofixed=1;
+    if (!stralloc_copys(&rcptto, "T")) die_nomem();
+    if (!stralloc_cats(&rcptto, x)) die_nomem();
+    if (!stralloc_0(&rcptto)) die_nomem();
+  }
+
+  /* esmtp auth options */
+  if (control_readint(&ctl_auth_delay,    "control/auth/delay") == -1) die_control();
+  if (control_readint(&ctl_auth_secure,   "control/auth/smtps") == -1) die_control();
+  if (control_readint(&ctl_auth_insecure, "control/auth/smtp")  == -1) die_control();
+  if (control_readint(&ctl_auth_oldauth,  "control/auth/oldauth") == -1) die_control();
+
+  /* checking of sender/recipient via external program */
+  ctl_rcptchecks = control_readline(&rcptchk, "control/rcptcheck");
+  if (ctl_rcptchecks == -1) die_control();
+  x=env_get("RCPTCHECK"); /* overrides controlfile */
+  if (x) { ctl_rcptchecks=1; stralloc_copys(&rcptchk, x); }
+  if (ctl_rcptchecks) rcptchk.s[rcptchk.len]=0;
+
+  /* badhelo - checking against HELO/EHLO <xxx> */
+  if (env_get("NO_BADHELO")) {
+    ctl_bmh=0;
+  } else {
+    x = env_get("BADHELO"); if (!x) x = "control/badhelo";
+    ctl_bmh = control_readfile(&bmh,x,0);
+    if (ctl_bmh == -1) die_control();
+  }
+
+  /* badmailfrom - checking against MAIL FROM:<xxx> */
+  if (env_get("NO_BADMAILFROM")) {
+    ctl_bmf=0;
+  } else {
+    x = env_get("BADMAILFROM"); if (!x) x = "control/badmailfrom";
+    ctl_bmf = control_readfile(&bmf,x,0);
+    if (ctl_bmf == -1) die_control();
+  }
+
+  /* badmailto - checking against RCPT TO:<xxx> */
+  if (env_get("NO_BADMAILTO")) {
+    ctl_bmt=0;
+  } else {
+    x = env_get("BADMAILTO"); if (!x) x = "control/badmailto";
+    ctl_bmt = control_readfile(&bmt,x,0);
+    if (ctl_bmt == -1) die_control();
+  }
+
+  /* goodmailfrom - checking against MAIL FROM:<xxx> */
+  if (env_get("NO_GOODMAILFROM")) {
+    ctl_gmf=0;
+  } else {
+    x = env_get("GOODMAILFROM"); if (!x) x = "control/goodmailfrom";
+    ctl_gmf = control_readfile(&gmf,x,0);
+    if (ctl_gmf == -1) die_control();
+  }
+
+  /* maxrcpt */
+  if (env_get("NO_MAXRCPT")) {
+    ctl_bmf=0;
+  } else { /* XXX: should MAXRCPT contain the int? */
+    x = env_get("MAXRCPT"); if (!x) x = "control/maxrcpt";
+    if (control_readint(&ctl_maxrcpt,x,0) == -1) die_control();
+    if (ctl_maxrcpt < 0) ctl_maxrcpt=0;
+  }
+
+  /* maxhops limit is now changeable on the fly */
+  if (control_readint(&ctl_maxhops, "control/maxhops") == -1) die_control();
+  if (ctl_maxhops <= 0) ctl_maxhops=DEFAULT_MAXHOPS;
+
+  /* max length of an email address */
+  if (control_readint(&ctl_maxaddrlen, "control/maxaddrlen") == -1) die_control();
+  if (ctl_maxaddrlen <= 0) ctl_maxaddrlen=900; /* default from djb */
+
+  /* buffer limit for commands */
+  if (control_readint(&ctl_maxcmdlen, "control/maxcmdlen") == -1) die_control();
+  if (ctl_maxcmdlen < 0) ctl_maxcmdlen=0;
+
+  /* enforce <> in the mail from & rcpt to */
+  if (control_readint(&ctl_reqbrackets, "control/reqbrackets") == -1) die_control();
+  if (ctl_reqbrackets < 0) ctl_reqbrackets=1;
+
+  /* read file into dcf (date control file) */
+  ctl_datechecks = control_readfile(&dcf, "control/datechecks", 0);
+  if (ctl_datechecks == -1) die_control();
+
+  /* load ip blacklist of not useable ip's as dnsmx */
+  ctl_mxblacklist = control_readfile(&mxbl,"control/mxblacklist", 0);
+  if (ctl_mxblacklist == -1) die_control();
+  if (ctl_mxblacklist) {
+    int ip=0,i=0;
+    if (!stralloc_0(&mxbl)) die_nomem();
+    for (; i<mxbl.len; ++i)
+    if (mxbl.s[i]=='\n') {
+      ip++; mxbl.s[i]=0; if (ip>10000) die_control();
+    }
+  }
+
+  /* size limits */
+  if (control_readint(&ctl_databytesP,"control/databytes+") == -1) die_control();
+  if (ctl_databytesP <= 0) ctl_databytesP=5000;
+
+  if (control_readint(&ctl_databytes,"control/databytes") == -1) die_control();
+  x = env_get("DATABYTES");
+  if (x) { scan_ulong(x,&ctl_databytes); }
+  if (ctl_databytes < 0) ctl_databytes=0;
+
+  if (ctl_databytes) {
+    x=smtpsize;
+    x+=fmt_str(x,"250-SIZE ");
+    x+=fmt_uint(x,ctl_databytes);
+    *x=0;
+  }
+
+  x="unknown";
+  remoteip = env_get("TCPREMOTEIP");
+  if (!remoteip) remoteip = x;
+
+  local = env_get("TCPLOCALHOST");
+  if (!local) local = env_get("TCPLOCALIP");
+  if (!local) local = x;
+
+  remotehost = env_get("TCPREMOTEHOST");
+  if (!remotehost) remotehost = x;
+
+  remoteinfo  = env_get("TCPREMOTEINFO");
+  relayclient = env_get("RELAYCLIENT");
+  requireauth = env_get("REQUIREAUTH");
+
+  dohelo(remotehost);
 }
 
 struct commands smtpcommands[] = {
   { "rcpt", smtp_rcpt, 0 }
 , { "mail", smtp_mail, 0 }
+, { "rset", smtp_rset, 0 }
 , { "data", smtp_data, flush }
 , { "quit", smtp_quit, flush }
 , { "helo", smtp_helo, flush }
 , { "ehlo", smtp_ehlo, flush }
-, { "rset", smtp_rset, 0 }
 , { "help", smtp_help, flush }
-, { "noop", err_noop, flush }
-, { "vrfy", err_vrfy, flush }
-, { 0, err_unimpl, flush }
-} ;
+, { "auth", smtp_auth, flush }
+, { "noop", smtp_noop, flush }
+, { "vrfy", smtp_vrfy, flush }
+, { "starttls", smtp_starttls, flush }
+, { 0, err_unrecog, flush }
+};
 
-void main()
+int main(int argc, char **argv)
 {
+  int i=0;
+  childargs = argv + 1;
+
   sig_pipeignore();
-  if (chdir(auto_qmail) == -1) die_control();
   setup();
+  p0f_query();
+
+  tls_available = !!env_get("UCSPITLS");
+
   if (ipme_init() != 1) die_ipme();
-  smtp_greet("220 ");
-  out(" ESMTP\r\n");
-  if (commands(&ssin,&smtpcommands) == 0) die_read();
-  die_nomem();
+  while (1) {
+    i+=strlen(greeting.s+i)+1;
+    if (i >= greeting.len) {
+      doserv(); out("220 "); out(greeting.s); doeol(); break;
+    } else {
+      doserv(); out("220-"); out(greeting.s+i); doeol();
+    }
+  }
+
+  if (!*childargs) { auth_available=0; } else { auth_available=1; }
+  if (commands(&ssin, &sserr, &smtpcommands) == 0) die_read();
+  die();
+
+  return 0; /* gcc happyness */
 }
diff -urN qmail-1.03-vanilla/qmail-start.c qmail-1.03-md24/qmail-start.c
--- qmail-1.03-vanilla/qmail-start.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-start.c	2007-07-19 20:56:22.000000000 +0200
@@ -27,7 +27,7 @@
   close(pi5[0]); close(pi5[1]); close(pi6[0]); close(pi6[1]);
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -117,4 +117,5 @@
   closepipes();
   execvp(*qsargs,qsargs);
   die();
+  return 0; /* cc happyness */
 }
diff -urN qmail-1.03-vanilla/qmail-tcpok.c qmail-1.03-md24/qmail-tcpok.c
--- qmail-1.03-vanilla/qmail-tcpok.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-tcpok.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "strerr.h"
 #include "substdio.h"
 #include "lock.h"
@@ -11,7 +13,7 @@
 char buf[1024]; /* XXX: must match size in tcpto_clean.c, tcpto.c */
 substdio ss;
 
-void main()
+int main()
 {
   int fd;
   int i;
diff -urN qmail-1.03-vanilla/qmail-tcpto.c qmail-1.03-md24/qmail-tcpto.c
--- qmail-1.03-vanilla/qmail-tcpto.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/qmail-tcpto.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,5 +1,7 @@
 /* XXX: this program knows quite a bit about tcpto's internals */
 
+#include <sys/types.h>
+#include <unistd.h>
 #include "substdio.h"
 #include "subfd.h"
 #include "auto_qmail.h"
@@ -10,6 +12,8 @@
 #include "exit.h"
 #include "datetime.h"
 #include "now.h"
+#include "open.h"
+#include "byte.h"
 
 void die(n) int n; { substdio_flush(subfdout); _exit(n); }
 
@@ -32,7 +36,7 @@
 
 char tmp[FMT_ULONG + IPFMT];
 
-void main()
+int main()
 {
  int fdlock;
  int fd;
@@ -81,5 +85,6 @@
    record += 16;
   }
 
- die(0);
+ _exit(0);
+ return 0;
 }
